package com.scenegraphshell;

import com.sun.scenario.scenegraph.SGNode;
import com.sun.scenario.scenegraph.SGGroup;
import com.sun.scenario.animation.Timeline;
import bsh.EvalError;
import bsh.Interpreter;


/**
 *
 */
public class BeanShellInterpreter implements CompilerInterface{
    private SGGroup group;
    private Timeline timeline;

    public void evaluate(String code) throws CompileError {
        try{
            Interpreter bsh = new Interpreter();
            bsh.eval("import com.sun.scenario.scenegraph.*;"); // import statements
            bsh.eval("import com.sun.scenario.animation.*;"); // import statements
            bsh.eval("final SGGroup root = new SGGroup();"); // create root
            bsh.eval("final Timeline timeline = new Timeline();"); // create timeline
            bsh.eval("setStrictJava(true);");
            bsh.eval( code);
            group = (SGGroup)bsh.eval("return root;");
            timeline = (Timeline) bsh.eval("return timeline;");
        }
        catch (EvalError evalError){
            throw new CompileError(evalError);
        }
    }

    public SGNode getSNNodeInstance() {
        return group;
    }

    public Timeline getTimeline() {
        return timeline;
    }
}
